library test.encode;

import 'package:test/test.dart';
import 'package:jaguar_jwt/jaguar_jwt.dart';

final key = 'secret';

main() {
  group('Encoding', () {
    test('Nopayload', () {
      final claimSet = new JwtClaim(
          issuer: 'teja',
          subject: '1234567890',
          audience: ["admin", "students"],
          issuedAt: new DateTime.fromMillisecondsSinceEpoch(1481842800000,
              isUtc: true));
      String token = issueJwtHS256(claimSet, key);
      expect(token,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOlsiYWRtaW4iLCJzdHVkZW50cyJdLCJleHAiOjg2NDAwLCJpYXQiOjE0ODE4NDI4MDAsImlzcyI6InRlamEiLCJzdWIiOiIxMjM0NTY3ODkwIn0=.xtJbJ4lurm4HnflBN5V2LVamfqc3RK8lo20lRv_ffNw=');
    });

    test('With payload', () {
      final claimSet = new JwtClaim(
          issuer: 'teja',
          subject: '1234567890',
          audience: ["admin", "students"],
          issuedAt: new DateTime.fromMillisecondsSinceEpoch(1481842800000,
              isUtc: true),
          payload: {"k": "v"});
      String token = issueJwtHS256(claimSet, key);
      expect(token,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOlsiYWRtaW4iLCJzdHVkZW50cyJdLCJleHAiOjg2NDAwLCJpYXQiOjE0ODE4NDI4MDAsImlzcyI6InRlamEiLCJwbGQiOnsiayI6InYifSwic3ViIjoiMTIzNDU2Nzg5MCJ9.FniGPl78JT0AkqAVw9CR_lNE1xR31FPqtzYuL513dlE=');
    });
  });
}
